Method: images.insert  |  Compute Engine  |  Google Cloud Documentation (original) (raw)

Creates an image in the specified project using the data included in the request.

HTTP request

POST https://compute.googleapis.com/compute/v1/projects/{project}/global/images

The URL uses gRPC Transcoding syntax. To know more about valid error responses that can be thrown by this HTTP request, please refer to the service error catalog

Path parameters

Parameters
project string Project ID for this request.

Query parameters

Parameters
requestId string An optional request ID to identify requests. Specify a unique request ID so that if you must retry your request, the server will know to ignore the request if it has already been completed.For example, consider a situation where you make an initial request and the request times out. If you make the request again with the same request ID, the server can check if original operation with the same request ID was received, and if so, will ignore the second request. This prevents clients from accidentally creating duplicate commitments.The request ID must be a valid UUID with the exception that zero UUID is not supported (00000000-0000-0000-0000-000000000000).
forceCreate boolean Force image creation if true.

Request body

The request body contains data with the following structure:

JSON representation
{ "kind": string, "id": string, "creationTimestamp": string, "name": string, "description": string, "sourceType": enum, "rawDisk": { "source": string, "sha1Checksum": string, "containerType": enum }, "deprecated": { "state": enum, "replacement": string, "deprecated": string, "obsolete": string, "deleted": string }, "status": enum, "archiveSizeBytes": string, "diskSizeGb": string, "sourceDisk": string, "sourceDiskId": string, "licenses": [ string ], "family": string, "imageEncryptionKey": { "rawKey": string, "rsaEncryptedKey": string, "kmsKeyName": string, "sha256": string, "kmsKeyServiceAccount": string }, "sourceDiskEncryptionKey": { "rawKey": string, "rsaEncryptedKey": string, "kmsKeyName": string, "sha256": string, "kmsKeyServiceAccount": string }, "selfLink": string, "labels": { string: string, ... }, "labelFingerprint": string, "guestOsFeatures": [ { "type": enum } ], "licenseCodes": [ string ], "sourceImage": string, "sourceImageId": string, "sourceImageEncryptionKey": { "rawKey": string, "rsaEncryptedKey": string, "kmsKeyName": string, "sha256": string, "kmsKeyServiceAccount": string }, "sourceSnapshot": string, "sourceSnapshotId": string, "sourceSnapshotEncryptionKey": { "rawKey": string, "rsaEncryptedKey": string, "kmsKeyName": string, "sha256": string, "kmsKeyServiceAccount": string }, "storageLocations": [ string ], "shieldedInstanceInitialState": { "pk": { "content": string, "fileType": enum }, "keks": [ { "content": string, "fileType": enum } ], "dbs": [ { "content": string, "fileType": enum } ], "dbxs": [ { "content": string, "fileType": enum } ] }, "satisfiesPzs": boolean, "architecture": enum, "enableConfidentialCompute": boolean, "satisfiesPzi": boolean, "params": { "resourceManagerTags": { string: string, ... } } }
Fields
kind string Output only. Type of the resource. Always compute#image for images.
id string (uint64 format) Output only. The unique identifier for the resource. This identifier is defined by the server.
creationTimestamp string Output only. Creation timestamp in RFC3339 text format.
name string [REQUIRED] Name of the resource; provided by the client when the resource is created. The name must be 1-63 characters long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular expression [a-z]([-a-z0-9]*[a-z0-9])? which means the first character must be a lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash.
description string An optional description of this resource. Provide this property when you create the resource.
sourceType enum The type of the image used to create this disk. The default and only valid value is RAW.
rawDisk object The parameters of the raw disk image.
rawDisk.source string The full Google Cloud Storage URL or Artifact Registry path where the raw disk image archive is stored. The following are valid formats: https://storage.googleapis.com/bucketName/image_archive_name https://storage.googleapis.com/bucketName/folder_name/image_archive_name projects/project/locations/location/repositories/repo/packages/package/versions/version_id projects/project/locations/location/repositories/repo/packages/package/versions/version_id@dirsum_sha256:hex_value In order to create an image, you must provide the full or partial URL of one of the following: The rawDisk.source URL The sourceDisk URL The sourceImage URL The sourceSnapshot URL
rawDisk.sha1Checksum**(deprecated)** string [Deprecated] This field is deprecated. An optional SHA1 checksum of the disk image before unpackaging provided by the client when the disk image is created.
rawDisk.containerType enum The format used to encode and transmit the block device, which should be TAR. This is just a container and transmission format and not a runtime format. Provided by the client when the disk image is created.
deprecated object Output only. The deprecation status associated with this image.
deprecated.state enum The deprecation state of this resource. This can be ACTIVE, DEPRECATED, OBSOLETE, or DELETED. Operations which communicate the end of life date for an image, can use ACTIVE. Operations which create a new resource using a DEPRECATED resource will return successfully, but with a warning indicating the deprecated resource and recommending its replacement. Operations which use OBSOLETE or DELETED resources will be rejected and result in an error.
deprecated.replacement string The URL of the suggested replacement for a deprecated resource. The suggested replacement resource must be the same kind of resource as the deprecated resource.
deprecated.deprecated string An optional RFC3339 timestamp on or after which the state of this resource is intended to change to DEPRECATED. This is only informational and the status will not change unless the client explicitly changes it.
deprecated.obsolete string An optional RFC3339 timestamp on or after which the state of this resource is intended to change to OBSOLETE. This is only informational and the status will not change unless the client explicitly changes it.
deprecated.deleted string An optional RFC3339 timestamp on or after which the state of this resource is intended to change to DELETED. This is only informational and the status will not change unless the client explicitly changes it.
status enum Output only. The status of the image. An image can be used to create other resources, such as instances, only after the image has been successfully created and the status is set to READY. Possible values are FAILED, PENDING, or READY.
archiveSizeBytes string (int64 format) Size of the image tar.gz archive stored in Google Cloud Storage (in bytes).
diskSizeGb string (int64 format) Size of the image when restored onto a persistent disk (in GB).
sourceDisk string URL of the source disk used to create this image. For example, the following are valid values: https://www.googleapis.com/compute/v1/projects/project/zones/zone/disks/disk projects/project/zones/zone/disks/disk zones/zone/disks/diskIn order to create an image, you must provide the full or partial URL of one of the following: The rawDisk.source URL The sourceDisk URL The sourceImage URL The sourceSnapshot URL Authorization requires the following IAM permission on the specified resource sourceDisk: compute.disks.useReadOnly
sourceDiskId string Output only. The ID value of the disk used to create this image. This value may be used to determine whether the image was taken from the current or a previous instance of a given disk name.
licenses[] string Any applicable license URI.
family string The name of the image family to which this image belongs. The image family name can be from a publicly managed image family provided by Compute Engine, or from a custom image family you create. For example, centos-stream-9 is a publicly available image family. For more information, see Image family best practices.When creating disks, you can specify an image family instead of a specific image name. The image family always returns its latest image that is not deprecated. The name of the image family must comply with RFC1035.
imageEncryptionKey object Encrypts the image using a customer-supplied encryption key.After you encrypt an image with a customer-supplied key, you must provide the same key if you use the image later (e.g. to create a disk from the image).Customer-supplied encryption keys do not protect access to metadata of the disk.If you do not provide an encryption key when creating the image, then the disk will be encrypted using an automatically generated key and you do not need to provide a key to use the image later.
imageEncryptionKey.rawKey string Specifies a 256-bit customer-supplied encryption key, encoded in RFC 4648 base64 to either encrypt or decrypt this resource. You can provide either the rawKey or the rsaEncryptedKey. For example: "rawKey": "SGVsbG8gZnJvbSBHb29nbGUgQ2xvdWQgUGxhdGZvcm0="
imageEncryptionKey.rsaEncryptedKey string Specifies an RFC 4648 base64 encoded, RSA-wrapped 2048-bit customer-supplied encryption key to either encrypt or decrypt this resource. You can provide either the rawKey or the rsaEncryptedKey. For example: "rsaEncryptedKey": "ieCx/NcW06PcT7Ep1X6LUTc/hLvUDYyzSZPPVCVPTVEohpeHASqC8uw5TzyO9U+Fka9JFH z0mBibXUInrC/jEk014kCK/NPjYgEMOyssZ4ZINPKxlUh2zn1bV+MCaTICrdmuSBTWlUUiFoD D6PYznLwh8ZNdaheCeZ8ewEXgFQ8V+sDroLaN3Xs3MDTXQEMMoNUXMCZEIpg9Vtp9x2oe==" The key must meet the following requirements before you can provide it to Compute Engine: The key is wrapped using a RSA public key certificate provided by Google. After being wrapped, the key must be encoded in RFC 4648 base64 encoding. Gets the RSA public key certificate provided by Google at: https://cloud-certs.storage.googleapis.com/google-cloud-csek-ingress.pem
imageEncryptionKey.kmsKeyName string The name of the encryption key that is stored in Google Cloud KMS. For example: "kmsKeyName": "projects/ kms_project_id/locations/ region/keyRings/ key_region/cryptoKeys/key The fully-qualifed key name may be returned for resource GET requests. For example: "kmsKeyName": "projects/ kms_project_id/locations/ region/keyRings/ key_region/cryptoKeys/key /cryptoKeyVersions/1
imageEncryptionKey.sha256 string Output only. The RFC 4648 base64 encoded SHA-256 hash of the customer-supplied encryption key that protects this resource.
imageEncryptionKey.kmsKeyServiceAccount string The service account being used for the encryption request for the given KMS key. If absent, the Compute Engine default service account is used. For example: "kmsKeyServiceAccount": "name@ projectId.iam.gserviceaccount.com/
sourceDiskEncryptionKey object The customer-supplied encryption key of the source disk. Required if the source disk is protected by a customer-supplied encryption key.
sourceDiskEncryptionKey.rawKey string Specifies a 256-bit customer-supplied encryption key, encoded in RFC 4648 base64 to either encrypt or decrypt this resource. You can provide either the rawKey or the rsaEncryptedKey. For example: "rawKey": "SGVsbG8gZnJvbSBHb29nbGUgQ2xvdWQgUGxhdGZvcm0="
sourceDiskEncryptionKey.rsaEncryptedKey string Specifies an RFC 4648 base64 encoded, RSA-wrapped 2048-bit customer-supplied encryption key to either encrypt or decrypt this resource. You can provide either the rawKey or the rsaEncryptedKey. For example: "rsaEncryptedKey": "ieCx/NcW06PcT7Ep1X6LUTc/hLvUDYyzSZPPVCVPTVEohpeHASqC8uw5TzyO9U+Fka9JFH z0mBibXUInrC/jEk014kCK/NPjYgEMOyssZ4ZINPKxlUh2zn1bV+MCaTICrdmuSBTWlUUiFoD D6PYznLwh8ZNdaheCeZ8ewEXgFQ8V+sDroLaN3Xs3MDTXQEMMoNUXMCZEIpg9Vtp9x2oe==" The key must meet the following requirements before you can provide it to Compute Engine: The key is wrapped using a RSA public key certificate provided by Google. After being wrapped, the key must be encoded in RFC 4648 base64 encoding. Gets the RSA public key certificate provided by Google at: https://cloud-certs.storage.googleapis.com/google-cloud-csek-ingress.pem
sourceDiskEncryptionKey.kmsKeyName string The name of the encryption key that is stored in Google Cloud KMS. For example: "kmsKeyName": "projects/ kms_project_id/locations/ region/keyRings/ key_region/cryptoKeys/key The fully-qualifed key name may be returned for resource GET requests. For example: "kmsKeyName": "projects/ kms_project_id/locations/ region/keyRings/ key_region/cryptoKeys/key /cryptoKeyVersions/1
sourceDiskEncryptionKey.sha256 string Output only. The RFC 4648 base64 encoded SHA-256 hash of the customer-supplied encryption key that protects this resource.
sourceDiskEncryptionKey.kmsKeyServiceAccount string The service account being used for the encryption request for the given KMS key. If absent, the Compute Engine default service account is used. For example: "kmsKeyServiceAccount": "name@ projectId.iam.gserviceaccount.com/
selfLink string Output only. Server-defined URL for the resource.
labels map (key: string, value: string) Labels to apply to this image. These can be later modified by the setLabels method. Authorization requires the following IAM permission on the specified resource labels: compute.images.setLabels
labelFingerprint string (bytes format) A fingerprint for the labels being applied to this image, which is essentially a hash of the labels used for optimistic locking. The fingerprint is initially generated by Compute Engine and changes after every request to modify or update labels. You must always provide an up-to-date fingerprint hash in order to update or change labels, otherwise the request will fail with error 412 conditionNotMet.To see the latest fingerprint, make a get() request to retrieve an image.A base64-encoded string.
guestOsFeatures[] object A list of features to enable on the guest operating system. Applicable only for bootable images. To see a list of available options, see the guestOSfeatures[].type parameter.
guestOsFeatures[].type enum The ID of a supported feature. To add multiple values, use commas to separate values. Set to one or more of the following values: VIRTIO_SCSI_MULTIQUEUE WINDOWS MULTI_IP_SUBNET UEFI_COMPATIBLE GVNIC SEV_CAPABLE SUSPEND_RESUME_COMPATIBLE SEV_LIVE_MIGRATABLE_V2 SEV_SNP_CAPABLE TDX_CAPABLE IDPF SNP_SVSM_CAPABLE CCA_CAPABLE For more information, see Enabling guest operating system features.
licenseCodes[] string (int64 format) Integer license codes indicating which licenses are attached to this image.
sourceImage string URL of the source image used to create this image. The following are valid formats for the URL: https://www.googleapis.com/compute/v1/projects/projectId/global/ images/image_name projects/projectId/global/images/image_name In order to create an image, you must provide the full or partial URL of one of the following: The rawDisk.source URL The sourceDisk URL The sourceImage URL The sourceSnapshot URL Authorization requires the following IAM permission on the specified resource sourceImage: compute.images.useReadOnly
sourceImageId string Output only. The ID value of the image used to create this image. This value may be used to determine whether the image was taken from the current or a previous instance of a given image name.
sourceImageEncryptionKey object The customer-supplied encryption key of the source image. Required if the source image is protected by a customer-supplied encryption key.
sourceImageEncryptionKey.rawKey string Specifies a 256-bit customer-supplied encryption key, encoded in RFC 4648 base64 to either encrypt or decrypt this resource. You can provide either the rawKey or the rsaEncryptedKey. For example: "rawKey": "SGVsbG8gZnJvbSBHb29nbGUgQ2xvdWQgUGxhdGZvcm0="
sourceImageEncryptionKey.rsaEncryptedKey string Specifies an RFC 4648 base64 encoded, RSA-wrapped 2048-bit customer-supplied encryption key to either encrypt or decrypt this resource. You can provide either the rawKey or the rsaEncryptedKey. For example: "rsaEncryptedKey": "ieCx/NcW06PcT7Ep1X6LUTc/hLvUDYyzSZPPVCVPTVEohpeHASqC8uw5TzyO9U+Fka9JFH z0mBibXUInrC/jEk014kCK/NPjYgEMOyssZ4ZINPKxlUh2zn1bV+MCaTICrdmuSBTWlUUiFoD D6PYznLwh8ZNdaheCeZ8ewEXgFQ8V+sDroLaN3Xs3MDTXQEMMoNUXMCZEIpg9Vtp9x2oe==" The key must meet the following requirements before you can provide it to Compute Engine: The key is wrapped using a RSA public key certificate provided by Google. After being wrapped, the key must be encoded in RFC 4648 base64 encoding. Gets the RSA public key certificate provided by Google at: https://cloud-certs.storage.googleapis.com/google-cloud-csek-ingress.pem
sourceImageEncryptionKey.kmsKeyName string The name of the encryption key that is stored in Google Cloud KMS. For example: "kmsKeyName": "projects/ kms_project_id/locations/ region/keyRings/ key_region/cryptoKeys/key The fully-qualifed key name may be returned for resource GET requests. For example: "kmsKeyName": "projects/ kms_project_id/locations/ region/keyRings/ key_region/cryptoKeys/key /cryptoKeyVersions/1
sourceImageEncryptionKey.sha256 string Output only. The RFC 4648 base64 encoded SHA-256 hash of the customer-supplied encryption key that protects this resource.
sourceImageEncryptionKey.kmsKeyServiceAccount string The service account being used for the encryption request for the given KMS key. If absent, the Compute Engine default service account is used. For example: "kmsKeyServiceAccount": "name@ projectId.iam.gserviceaccount.com/
sourceSnapshot string URL of the source snapshot used to create this image. The following are valid formats for the URL: https://www.googleapis.com/compute/v1/projects/projectId/global/ snapshots/snapshotName projects/projectId/global/snapshots/snapshotName In order to create an image, you must provide the full or partial URL of one of the following: The rawDisk.source URL The sourceDisk URL The sourceImage URL The sourceSnapshot URL Authorization requires the following IAM permission on the specified resource sourceSnapshot: compute.snapshots.useReadOnly
sourceSnapshotId string Output only. The ID value of the snapshot used to create this image. This value may be used to determine whether the snapshot was taken from the current or a previous instance of a given snapshot name.
sourceSnapshotEncryptionKey object The customer-supplied encryption key of the source snapshot. Required if the source snapshot is protected by a customer-supplied encryption key.
sourceSnapshotEncryptionKey.rawKey string Specifies a 256-bit customer-supplied encryption key, encoded in RFC 4648 base64 to either encrypt or decrypt this resource. You can provide either the rawKey or the rsaEncryptedKey. For example: "rawKey": "SGVsbG8gZnJvbSBHb29nbGUgQ2xvdWQgUGxhdGZvcm0="
sourceSnapshotEncryptionKey.rsaEncryptedKey string Specifies an RFC 4648 base64 encoded, RSA-wrapped 2048-bit customer-supplied encryption key to either encrypt or decrypt this resource. You can provide either the rawKey or the rsaEncryptedKey. For example: "rsaEncryptedKey": "ieCx/NcW06PcT7Ep1X6LUTc/hLvUDYyzSZPPVCVPTVEohpeHASqC8uw5TzyO9U+Fka9JFH z0mBibXUInrC/jEk014kCK/NPjYgEMOyssZ4ZINPKxlUh2zn1bV+MCaTICrdmuSBTWlUUiFoD D6PYznLwh8ZNdaheCeZ8ewEXgFQ8V+sDroLaN3Xs3MDTXQEMMoNUXMCZEIpg9Vtp9x2oe==" The key must meet the following requirements before you can provide it to Compute Engine: The key is wrapped using a RSA public key certificate provided by Google. After being wrapped, the key must be encoded in RFC 4648 base64 encoding. Gets the RSA public key certificate provided by Google at: https://cloud-certs.storage.googleapis.com/google-cloud-csek-ingress.pem
sourceSnapshotEncryptionKey.kmsKeyName string The name of the encryption key that is stored in Google Cloud KMS. For example: "kmsKeyName": "projects/ kms_project_id/locations/ region/keyRings/ key_region/cryptoKeys/key The fully-qualifed key name may be returned for resource GET requests. For example: "kmsKeyName": "projects/ kms_project_id/locations/ region/keyRings/ key_region/cryptoKeys/key /cryptoKeyVersions/1
sourceSnapshotEncryptionKey.sha256 string Output only. The RFC 4648 base64 encoded SHA-256 hash of the customer-supplied encryption key that protects this resource.
sourceSnapshotEncryptionKey.kmsKeyServiceAccount string The service account being used for the encryption request for the given KMS key. If absent, the Compute Engine default service account is used. For example: "kmsKeyServiceAccount": "name@ projectId.iam.gserviceaccount.com/
storageLocations[] string Cloud Storage bucket storage location of the image (regional or multi-regional).
shieldedInstanceInitialState object Set the secure boot keys of shielded instance.
shieldedInstanceInitialState.pk object The Platform Key (PK).
shieldedInstanceInitialState.pk.content string (bytes format) The raw content in the secure keys file.A base64-encoded string.
shieldedInstanceInitialState.pk.fileType enum The file type of source file.
shieldedInstanceInitialState.keks[] object The Key Exchange Key (KEK).
shieldedInstanceInitialState.keks[].content string (bytes format) The raw content in the secure keys file.A base64-encoded string.
shieldedInstanceInitialState.keks[].fileType enum The file type of source file.
shieldedInstanceInitialState.dbs[] object The Key Database (db).
shieldedInstanceInitialState.dbs[].content string (bytes format) The raw content in the secure keys file.A base64-encoded string.
shieldedInstanceInitialState.dbs[].fileType enum The file type of source file.
shieldedInstanceInitialState.dbxs[] object The forbidden key database (dbx).
shieldedInstanceInitialState.dbxs[].content string (bytes format) The raw content in the secure keys file.A base64-encoded string.
shieldedInstanceInitialState.dbxs[].fileType enum The file type of source file.
satisfiesPzs boolean Output only. Reserved for future use.
architecture enum The architecture of the image. Valid values are ARM64 or X86_64.
enableConfidentialCompute boolean Output only. Whether this image is created from a confidential compute mode disk. Output only.: This field is not set by user, but from source disk.
satisfiesPzi boolean Output only. Reserved for future use.
params object Input only. [Input Only] Additional params passed with the request, but not persisted as part of resource payload.
params.resourceManagerTags map (key: string, value: string) Input only. Resource manager tags to be bound to the image. Tag keys and values have the same definition as resource manager tags. Keys and values can be either in numeric format, such as tagKeys/{tag_key_id} and tagValues/{tag_value_id} or in namespaced format such as {org_id|projectId}/{tag_key_short_name} and {tag_value_short_name}. The field is ignored (both PUT & PATCH) when empty.

Response body

Represents an Operation resource.

Google Compute Engine has three Operation resources:

You can use an operation resource to manage asynchronous API requests. For more information, read Handling API responses.

Operations can be global, regional or zonal.

For more information, read Global, Regional, and Zonal Resources.

Note that completed Operation resources have a limited retention period.

If successful, the response body contains data with the following structure:

JSON representation
{ "kind": string, "id": string, "creationTimestamp": string, "name": string, "zone": string, "clientOperationId": string, "operationType": string, "targetLink": string, "targetId": string, "status": enum, "statusMessage": string, "user": string, "progress": integer, "insertTime": string, "startTime": string, "endTime": string, "error": { "errors": [ { "code": string, "location": string, "message": string, "errorDetails": [ { "errorInfo": { "reason": string, "domain": string, "metadatas": { string: string, ... } }, "quotaInfo": { "metricName": string, "limitName": string, "dimensions": { string: string, ... }, "limit": number, "futureLimit": number, "rolloutStatus": enum }, "help": { "links": [ { "description": string, "url": string } ] }, "localizedMessage": { "locale": string, "message": string } } ] } ] }, "warnings": [ { "code": enum, "message": string, "data": [ { "key": string, "value": string } ] } ], "httpErrorStatusCode": integer, "httpErrorMessage": string, "selfLink": string, "region": string, "description": string, "operationGroupId": string, // Union field metadata can be only one of the following: "setCommonInstanceMetadataOperationMetadata": { "clientOperationId": string, "perLocationOperations": { string: { "state": enum, "error": { "code": integer, "message": string, "details": [ { "@type": string, field1: ..., ... } ] } }, ... } }, "instancesBulkInsertOperationMetadata": { "perLocationStatus": { string: { "status": enum, "targetVmCount": integer, "createdVmCount": integer, "failedToCreateVmCount": integer, "deletedVmCount": integer }, ... } }, "getVersionOperationMetadata": { "inlineSbomInfo": { "currentComponentVersions": { string: string, ... }, "targetComponentVersions": { string: string, ... } } } // End of list of possible types for union field metadata. }
Fields
kind string Output only. Type of the resource. Always compute#operation for Operation resources.
id string (uint64 format) Output only. The unique identifier for the operation. This identifier is defined by the server.
creationTimestamp string [Deprecated] This field is deprecated.
name string Output only. Name of the operation.
zone string Output only. The URL of the zone where the operation resides. Only applicable when performing per-zone operations.
clientOperationId string Output only. The value of requestId if you provided it in the request. Not present otherwise.
operationType string Output only. The type of operation, such as insert, update, or delete, and so on.
targetLink string Output only. The URL of the resource that the operation modifies. For operations related to creating a snapshot, this points to the disk that the snapshot was created from.
targetId string (uint64 format) Output only. The unique target ID, which identifies a specific incarnation of the target resource.
status enum Output only. The status of the operation, which can be one of the following: PENDING, RUNNING, or DONE.
statusMessage string Output only. An optional textual description of the current status of the operation.
user string Output only. User who requested the operation, for example: user@example.com or alice_smith_identifier (global/workforcePools/example-com-us-employees).
progress integer Output only. An optional progress indicator that ranges from 0 to 100. There is no requirement that this be linear or support any granularity of operations. This should not be used to guess when the operation will be complete. This number should monotonically increase as the operation progresses.
insertTime string Output only. The time that this operation was requested. This value is in RFC3339 text format.
startTime string Output only. The time that this operation was started by the server. This value is in RFC3339 text format.
endTime string Output only. The time that this operation was completed. This value is in RFC3339 text format.
error object Output only. If errors are generated during processing of the operation, this field will be populated.
error.errors[] object Output only. The array of errors encountered while processing this operation.
error.errors[].code string Output only. The error type identifier for this error.
error.errors[].location string Output only. Indicates the field in the request that caused the error. This property is optional.
error.errors[].message string Output only. An optional, human-readable error message.
error.errors[].errorDetails[] object Output only. An optional list of messages that contain the error details. There is a set of defined message types to use for providing details.The syntax depends on the error code. For example, QuotaExceededInfo will have details when the error code is QUOTA_EXCEEDED.
error.errors[].errorDetails[].errorInfo object
error.errors[].errorDetails[].errorInfo.reason string The reason of the error. This is a constant value that identifies the proximate cause of the error. Error reasons are unique within a particular domain of errors. This should be at most 63 characters and match a regular expression of [A-Z][A-Z0-9_]+[A-Z0-9], which represents UPPER_SNAKE_CASE.
error.errors[].errorDetails[].errorInfo.domain string The logical grouping to which the "reason" belongs. The error domain is typically the registered service name of the tool or product that generates the error. Example: "pubsub.googleapis.com". If the error is generated by some common infrastructure, the error domain must be a globally unique value that identifies the infrastructure. For Google API infrastructure, the error domain is "googleapis.com".
error.errors[].errorDetails[].errorInfo.metadatas map (key: string, value: string) Additional structured details about this error.Keys must match a regular expression of [a-z][a-zA-Z0-9-_]+ but should ideally be lowerCamelCase. Also, they must be limited to 64 characters in length. When identifying the current value of an exceeded limit, the units should be contained in the key, not the value. For example, rather than {"instanceLimit": "100/request"}, should be returned as, {"instanceLimitPerRequest": "100"}, if the client exceeds the number of instances that can be created in a single (batch) request.
error.errors[].errorDetails[].quotaInfo object
error.errors[].errorDetails[].quotaInfo.metricName string The Compute Engine quota metric name.
error.errors[].errorDetails[].quotaInfo.limitName string The name of the quota limit.
error.errors[].errorDetails[].quotaInfo.dimensions map (key: string, value: string) The map holding related quota dimensions.
error.errors[].errorDetails[].quotaInfo.limit number Current effective quota limit. The limit's unit depends on the quota type or metric.
error.errors[].errorDetails[].quotaInfo.futureLimit number Future quota limit being rolled out. The limit's unit depends on the quota type or metric.
error.errors[].errorDetails[].quotaInfo.rolloutStatus enum Rollout status of the future quota limit.
error.errors[].errorDetails[].help object
error.errors[].errorDetails[].help.links[] object URL(s) pointing to additional information on handling the current error.
error.errors[].errorDetails[].help.links[].description string Describes what the link offers.
error.errors[].errorDetails[].help.links[].url string The URL of the link.
error.errors[].errorDetails[].localizedMessage object
error.errors[].errorDetails[].localizedMessage.locale string The locale used following the specification defined at https://www.rfc-editor.org/rfc/bcp/bcp47.txt. Examples are: "en-US", "fr-CH", "es-MX"
error.errors[].errorDetails[].localizedMessage.message string The localized error message in the above locale.
warnings[] object Output only. If warning messages are generated during processing of the operation, this field will be populated.
warnings[].code enum Output only. A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if there are no results in the response.
warnings[].message string Output only. A human-readable description of the warning code.
warnings[].data[] object Output only. Metadata about this warning in key: value format. For example: "data": [ { "key": "scope", "value": "zones/us-east1-d" }
warnings[].data[].key string Output only. A key that provides more detail on the warning being returned. For example, for warnings where there are no results in a list request for a particular zone, this key might be scope and the key value might be the zone name. Other examples might be a key indicating a deprecated resource and a suggested replacement, or a warning about invalid network settings (for example, if an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
warnings[].data[].value string Output only. A warning data value corresponding to the key.
httpErrorStatusCode integer Output only. If the operation fails, this field contains the HTTP error status code that was returned. For example, a 404 means the resource was not found.
httpErrorMessage string Output only. If the operation fails, this field contains the HTTP error message that was returned, such as NOT FOUND.
selfLink string Output only. Server-defined URL for the resource.
region string Output only. The URL of the region where the operation resides. Only applicable when performing regional operations.
description string Output only. A textual description of the operation, which is set when the operation is created.
operationGroupId string Output only. An ID that represents a group of operations, such as when a group of operations results from a bulkInsert API request.
Union field metadata. Output only. Service-specific metadata attached to this operation. metadata can be only one of the following:
setCommonInstanceMetadataOperationMetadata object Output only. If the operation is for projects.setCommonInstanceMetadata, this field will contain information on all underlying zonal actions and their state.
setCommonInstanceMetadataOperationMetadata.clientOperationId string Output only. The client operation id.
setCommonInstanceMetadataOperationMetadata.perLocationOperations[] map (key: string, value: object) Output only. Status information per location (location name is key). Example key: zones/us-central1-a
setCommonInstanceMetadataOperationMetadata.perLocationOperations[].state enum Output only. Status of the action, which can be one of the following: PROPAGATING, PROPAGATED, ABANDONED, FAILED, or DONE.
setCommonInstanceMetadataOperationMetadata.perLocationOperations[].error object Output only. If state is ABANDONED or FAILED, this field is populated.
setCommonInstanceMetadataOperationMetadata.perLocationOperations[].error.code integer The status code, which should be an enum value of google.rpc.Code.
setCommonInstanceMetadataOperationMetadata.perLocationOperations[].error.message string A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the google.rpc.Status.details field, or localized by the client.
setCommonInstanceMetadataOperationMetadata.perLocationOperations[].error.details[] object A list of messages that carry the error details. There is a common set of message types for APIs to use.An object containing fields of an arbitrary type. An additional field "@type" contains a URI identifying the type. Example: { "id": 1234, "@type": "types.example.com/standard/id" }.
instancesBulkInsertOperationMetadata object
instancesBulkInsertOperationMetadata.perLocationStatus[] map (key: string, value: object) Status information per location (location name is key). Example key: zones/us-central1-a
instancesBulkInsertOperationMetadata.perLocationStatus[].status enum Output only. Creation status of BulkInsert operation - information if the flow is rolling forward or rolling back.
instancesBulkInsertOperationMetadata.perLocationStatus[].targetVmCount integer Output only. Count of VMs originally planned to be created.
instancesBulkInsertOperationMetadata.perLocationStatus[].createdVmCount integer Output only. Count of VMs successfully created so far.
instancesBulkInsertOperationMetadata.perLocationStatus[].failedToCreateVmCount integer Output only. Count of VMs that started creating but encountered an error.
instancesBulkInsertOperationMetadata.perLocationStatus[].deletedVmCount integer Output only. Count of VMs that got deleted during rollback.
getVersionOperationMetadata object
getVersionOperationMetadata.inlineSbomInfo object
getVersionOperationMetadata.inlineSbomInfo.currentComponentVersions map (key: string, value: string) A mapping of components to their currently-applied versions or other appropriate identifiers.
getVersionOperationMetadata.inlineSbomInfo.targetComponentVersions map (key: string, value: string) A mapping of components to their target versions or other appropriate identifiers.

Requires one of the following OAuth scopes:

For more information, see the Authentication Overview.

IAM Permissions

In addition to any permissions specified on the fields above, authorization requires one or more of the following IAM permissions:

To find predefined roles that contain those permissions, see Compute Engine IAM Roles.